# VectorizedRNG

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaSIMD.github.io/VectorizedRNG.jl/stable)
[![Latest](https://img.shields.io/badge/docs-latest-blue.svg)](https://JuliaSIMD.github.io/VectorizedRNG.jl/dev)
[![CI](https://github.com/JuliaSIMD/VectorizedRNG.jl/workflows/CI/badge.svg)](https://github.com/JuliaSIMD/VectorizedRNG.jl/actions?query=workflow%3ACI)
[![CI (Julia nightly)](https://github.com/JuliaSIMD/VectorizedRNG.jl/workflows/CI%20(Julia%20nightly)/badge.svg)](https://github.com/JuliaSIMD/VectorizedRNG.jl/actions?query=workflow%3A%22CI+%28Julia+nightly%29%22)
[![Codecov](https://codecov.io/gh/JuliaSIMD/VectorizedRNG.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaSIMD/VectorizedRNG.jl)


This library provides a vectorized Xoshiro256++ random number generator. The larger the host computers SIMD vector width, the better they will perform. On a machine with AVX-512, they are faster than [SIMD-oriented Fast Mersenne Twister (SFMT)](http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/SFMT/). Base Julia used dSFMT, up to version 1.7, which in a few tests appears to outperform this library on AVX2 systems in generating uniformly distributed random numbers.

You can get a thread-local instance of the `Xoshiro` generator with `local_rng()`. Each parallel stream jumps ahead `2^128` samples, which should be more than enough samples per stream for any real calculation. Each thread gets 8 parallel streams with AVX, or 16 with AVX512, allowing there to be up to `2^125` or `2^124` threads with AVX512.

Testing on an old haswell machine (AVX2-only):
```julia
julia> using BenchmarkTools, Random, VectorizedRNG

julia> x = Vector{Float64}(undef, 1024);

julia> @benchmark randn!($x)
BenchmarkTools.Trial:
  memory estimate:  0 bytes
  allocs estimate:  0
  --------------
  minimum time:     7.235 μs (0.00% GC)
  median time:      7.900 μs (0.00% GC)
  mean time:        8.034 μs (0.00% GC)
  maximum time:     233.290 μs (0.00% GC)
  --------------
  samples:          10000
  evals/sample:     5
 
julia> @benchmark randn!(local_rng(), $x)
BenchmarkTools.Trial:
  memory estimate:  0 bytes
  allocs estimate:  0
  --------------
  minimum time:     3.744 μs (0.00% GC)
  median time:      4.156 μs (0.00% GC)
  mean time:        4.137 μs (0.00% GC)
  maximum time:     59.169 μs (0.00% GC)
  --------------
  samples:          10000
  evals/sample:     8
```
The performance advantage is thanks primarily to a fast SIMD [Box-Muller](https://en.wikipedia.org/wiki/Box%E2%80%93Muller_transform) implementation; `randn(::MersenneTwister)` uses the ziggurat algorithm, which is more efficient for scalars. Performance is closer when only comparing random-uniform generation:
```julia
julia> @benchmark rand!($x)
BenchmarkTools.Trial:
  memory estimate:  0 bytes
  allocs estimate:  0
  --------------
  minimum time:     791.047 ns (0.00% GC)
  median time:      904.541 ns (0.00% GC)
  mean time:        915.753 ns (0.00% GC)
  maximum time:     13.978 μs (0.00% GC)
  --------------
  samples:          10000
  evals/sample:     85
 
julia> @benchmark rand!(local_rng(), $x)
BenchmarkTools.Trial:
  memory estimate:  0 bytes
  allocs estimate:  0
  --------------
  minimum time:     513.000 ns (0.00% GC)
  median time:      568.578 ns (0.00% GC)
  mean time:        571.597 ns (0.00% GC)
  maximum time:     4.706 μs (0.00% GC)
  --------------
  samples:          10000
  evals/sample:     192
```
This library shines on a system with AVX512:
```julia
julia> using BenchmarkTools, Random, VectorizedRNG

julia> x = Vector{Float64}(undef, 1024);

julia> @benchmark randn!($x)
BenchmarkTools.Trial:
  memory estimate:  0 bytes
  allocs estimate:  0
  --------------
  minimum time:     1.676 μs (0.00% GC)
  median time:      1.798 μs (0.00% GC)
  mean time:        1.883 μs (0.00% GC)
  maximum time:     5.769 μs (0.00% GC)
  --------------
  samples:          10000
  evals/sample:     10

julia> @benchmark randn!(local_rng(), $x)
BenchmarkTools.Trial:
  memory estimate:  0 bytes
  allocs estimate:  0
  --------------
  minimum time:     854.446 ns (0.00% GC)
  median time:      962.369 ns (0.00% GC)
  mean time:        991.798 ns (0.00% GC)
  maximum time:     1.818 μs (0.00% GC)
  --------------
  samples:          10000
  evals/sample:     65

julia> @benchmark rand!($x)
BenchmarkTools.Trial:
  memory estimate:  0 bytes
  allocs estimate:  0
  --------------
  minimum time:     549.856 ns (0.00% GC)
  median time:      567.626 ns (0.00% GC)
  mean time:        603.958 ns (0.00% GC)
  maximum time:     1.124 μs (0.00% GC)
  --------------
  samples:          10000
  evals/sample:     187

julia> @benchmark rand!(local_rng(), $x)
BenchmarkTools.Trial:
  memory estimate:  0 bytes
  allocs estimate:  0
  --------------
  minimum time:     159.907 ns (0.00% GC)
  median time:      171.258 ns (0.00% GC)
  mean time:        174.272 ns (0.00% GC)
  maximum time:     958.197 ns (0.00% GC)
  --------------
  samples:          10000
  evals/sample:     788

julia> versioninfo()
Julia Version 1.6.0-DEV.1581
Commit 377aa809eb (2020-11-26 01:44 UTC)
Platform Info:
  OS: Linux (x86_64-linux-gnu)
  CPU: 11th Gen Intel(R) Core(TM) i7-1165G7 @ 2.80GHz
  WORD_SIZE: 64
  LIBM: libopenlibm
  LLVM: libLLVM-11.0.0 (ORCJIT, tigerlake)
```

## Setting the seed

VectorizedRNG is initialized with a random seed (based on the default `Random.GLOBAL_RNG`) when loaded, but `Random.seed!` wont change the state of the VectorizedRNG. You can set the seed of the VectorizedRNG with `VectorizedRNG.seed!`.

```julia
julia> using VectorizedRNG

julia> rand(local_rng(), 15)'
1×15 LinearAlgebra.Adjoint{Float64,Array{Float64,1}}:
 0.580812  0.813531  0.359055  0.590277  0.551968  0.635421  0.160614  0.312387  0.00787783  0.554571  0.368705  0.0219756  0.804188  0.0740875  0.939065

julia> VectorizedRNG.seed!(1)

julia> rand(local_rng(), 15)'
1×15 LinearAlgebra.Adjoint{Float64,Array{Float64,1}}:
 0.371016  0.804553  0.243923  0.261726  0.875966  0.942672  0.875786  0.0255004  0.236359  0.59697  0.480488  0.790366  0.0263995  0.715227  0.514725

julia> rand(local_rng(), 15)'
1×15 LinearAlgebra.Adjoint{Float64,Array{Float64,1}}:
 0.246595  0.326417  0.98997  0.335991  0.839723  0.628247  0.814513  0.924231  0.398405  0.604068  0.915064  0.984332  0.773448  0.325699  0.490881

julia> VectorizedRNG.seed!(1)

julia> rand(local_rng(), 15)'
1×15 LinearAlgebra.Adjoint{Float64,Array{Float64,1}}:
 0.371016  0.804553  0.243923  0.261726  0.875966  0.942672  0.875786  0.0255004  0.236359  0.59697  0.480488  0.790366  0.0263995  0.715227  0.514725

julia> rand(local_rng(), 15)'
1×15 LinearAlgebra.Adjoint{Float64,Array{Float64,1}}:
 0.246595  0.326417  0.98997  0.335991  0.839723  0.628247  0.814513  0.924231  0.398405  0.604068  0.915064  0.984332  0.773448  0.325699  0.490881
```

## BigCrush

The generators pass [BigCrush](https://github.com/andreasnoack/RNGTest.jl). We can run BigCrush in a matter of minutes on a multicore system (10980XE CPU). Testing the uniform number generator:
```julia
julia> using Distributed; addprocs(); nprocs()
37

julia> @everywhere using RNGTest, VectorizedRNG, Random

julia> @everywhere struct U01 <: Random.AbstractRNG end

julia> @everywhere Random.rand!(r::U01, x::AbstractArray) = rand!(local_rng(), x)

julia> u01 = U01()
U01()

julia> rngunif = RNGTest.wrap(U01(), Float64);

julia> @time bcjunif = RNGTest.bigcrushJulia(rngunif);
511.531281 seconds (31.91 M allocations: 1.619 GiB, 0.10% gc time)

julia> minimum(minimum.(bcjunif))
0.004345184234132201

julia> maximum(maximum.(bcjunif))
0.99900365621945
```
While not great looking minimum or maximum p-values. For comparison, the default MersenneTwister:
```julia
julia> wrappedtwister = RNGTest.wrap(MersenneTwister(), Float64);

julia> @time bcjmtwister = RNGTest.bigcrushJulia(wrappedtwister);
481.782432 seconds (9.73 M allocations: 508.753 MiB, 0.04% gc time)

julia> minimum(minimum.(bcjmtwister))
0.0015850804769910467

julia> maximum(maximum.(bcjmtwister))
0.9912021397939957
```
Interestingly, this completed faster. I should've monitored clock speeds, but can say that (subjectively) the CPU fans were louder when running this benchmark, making me wonder if this is a case where downclocking of non-AVX code decreases performance.

Watch out when mixing vectorized and non-vectorized code.

***

On vectorization: the strategy is to simply have many distinct streams, and sample from them simultaneously via SIMD operations.

module VectorizedRNG
if isdefined(Base, :Experimental) &&
   isdefined(Base.Experimental, Symbol("@max_methods"))
    @eval Base.Experimental.@max_methods 1
end

using VectorizationBase, Random, UnPack
using VectorizationBase:
  simd_integer_register_size,
  gep,
  _Vec,
  ifelse,
  VecUnroll,
  AbstractSIMD,
  rotate_right,
  vadd,
  vsub,
  zero_offsets,
  vfmadd,
  vfmsub,
  vfnmadd,
  shufflevector,
  register_size,
  cache_linesize,
  StaticInt,
  pick_vector_width,
  data
using SLEEFPirates

using Distributed: myid

if !isdefined(Base, :get_extension)
  using Requires
end

export local_rng, rand!, randn!#, randexp, randexp!

abstract type AbstractVRNG{N} <: Random.AbstractRNG end
abstract type AbstractState{N,W} end

@inline vloadu(ptr::Ptr) =
  VectorizationBase.__vload(ptr, VectorizationBase.False(), register_size())
@inline vloadu(ptr::Ptr, i) =
  VectorizationBase.__vload(ptr, i, VectorizationBase.False(), register_size())

const ALIGN = VectorizationBase.False()

@inline vloada(ptr::Ptr) =
  VectorizationBase.__vload(ptr, ALIGN, register_size())
@inline vloada(ptr::Ptr, i) =
  VectorizationBase.__vload(ptr, i, ALIGN, register_size())
@inline vloada(ptr::Ptr, i, m) =
  VectorizationBase.__vload(ptr, i, m, ALIGN, register_size())
@inline vstorea!(ptr::Ptr, v) = VectorizationBase.__vstore!(
  ptr,
  v,
  ALIGN,
  VectorizationBase.False(),
  VectorizationBase.False(),
  register_size()
)
@inline vstorea!(ptr::Ptr, v, i) = VectorizationBase.__vstore!(
  ptr,
  v,
  i,
  ALIGN,
  VectorizationBase.False(),
  VectorizationBase.False(),
  register_size()
)
@inline vstorea!(ptr::Ptr, v, i, m) = VectorizationBase.__vstore!(
  ptr,
  v,
  i,
  m,
  ALIGN,
  VectorizationBase.False(),
  VectorizationBase.False(),
  register_size()
)
@inline vstoreu!(ptr::Ptr, v, i) = VectorizationBase.__vstore!(
  ptr,
  v,
  i,
  VectorizationBase.False(),
  VectorizationBase.False(),
  VectorizationBase.False(),
  register_size()
)
@inline vstoreu!(ptr::Ptr, v) = VectorizationBase.__vstore!(
  ptr,
  v,
  VectorizationBase.False(),
  VectorizationBase.False(),
  VectorizationBase.False(),
  register_size()
)

include("masks.jl")
include("api.jl")
include("special_approximations.jl")
include("xoshiro.jl")
# const GLOBAL_vPCGs = Ref{Ptr{UInt64}}()

const GLOBAL_vRNGs = Ref{Ptr{UInt64}}()

const RNG_MEM_SIZE = (5(simd_integer_register_size() * XREGISTERS + 2048 * 3))
local_rng(i) = Xoshiro{XREGISTERS}(i * (RNG_MEM_SIZE) + GLOBAL_vRNGs[])
local_rng() = local_rng(Base.Threads.threadid() - 1)

function __init()
  nthreads = Base.Threads.nthreads()
  GLOBAL_vRNGs[] =
    ptr = VectorizationBase.valloc((RNG_MEM_SIZE ÷ 8) * nthreads, UInt64)
  nstreams = XREGISTERS * nthreads * simd_integer_register_size()
  initXoshiro!(ptr, nstreams)
  for tid ∈ 0:nthreads-1
    rng = local_rng(tid)
    setrandu64counter!(rng, 0x00)
    # setrandn32counter!(rng, 0x00)
    setrand64counter!(rng, 0x00)
    setrandn64counter!(rng, 0x00)
  end
end
function __init__()
  @static if !isdefined(Base, :get_extension)
    @require StaticArraysCore = "1e83bf80-4336-4d27-bf5d-d5a4f845583c" begin
      include("../ext/VectorizedRNGStaticArraysExt.jl")
    end
  end
  ccall(:jl_generating_output, Cint, ()) == 1 && return
  __init()
end

end # module

const XREGISTERS = 2

abstract type AbstractXoshiro{P} <: AbstractVRNG{P} end
struct Xoshiro{P} <: AbstractXoshiro{P}
  ptr::Ptr{UInt64}
end
@inline Base.pointer(rng::Xoshiro) = rng.ptr

struct XoshiroScalarState <: AbstractState{1,0}
  eins::UInt64
  zwei::UInt64
  drei::UInt64
  vier::UInt64
end
struct XoshiroState{P,W} <: AbstractState{P,W}
  eins::VecUnroll{P,W,UInt64,Vec{W,UInt64}}
  zwei::VecUnroll{P,W,UInt64,Vec{W,UInt64}}
  drei::VecUnroll{P,W,UInt64,Vec{W,UInt64}}
  vier::VecUnroll{P,W,UInt64,Vec{W,UInt64}}
end

Xoshiro(ptr, ::StaticInt{X}) where {X} = Xoshiro{X}(ptr)
Xoshiro(ptr) = Xoshiro(ptr, StaticInt(XREGISTERS))
randnonzero() = while true
    r = rand(UInt64)
    iszero(r) || return r
  end
function initXoshiro!(ptr::Ptr{UInt64}, P)
  e = randnonzero()
  z = randnonzero()
  d = randnonzero()
  v = randnonzero()
  initXoshiro!(ptr, P, e, z, d, v)
end
function initXoshiro!(
  ptr::Ptr{UInt64},
  P,
  e::UInt64,
  z::UInt64,
  d::UInt64,
  v::UInt64
) # P here means number of streams
  for j ∈ 1:P-1
    i = P - j
    vstoreu!(ptr, e, 8i)
    vstoreu!(ptr, z, 8 * (i + P))
    vstoreu!(ptr, d, 8 * (i + 2P))
    vstoreu!(ptr, v, 8 * (i + 3P))
    e, z, d, v = jump(e, z, d, v)
  end
  vstoreu!(ptr, e)
  vstoreu!(ptr, z, 8P)
  vstoreu!(ptr, d, 8 * (2P))
  vstoreu!(ptr, v, 8 * (3P))
  vstoreu!(Base.unsafe_convert(Ptr{UInt32}, ptr), 0x00000000, 8 * (4P))
end
function initXoshiro(::Val{P}, ::Val{W}) where {P,W}
  e = randnonzero()
  z = randnonzero()
  d = randnonzero()
  v = randnonzero()
  initXoshiro(Val{P}(), Val{W}(), e, z, d, v)
end
@generated function initXoshiro(
  ::Val{P},
  ::Val{W},
  e_0::UInt64,
  z_0::UInt64,
  d_0::UInt64,
  v_0::UInt64
) where {W,P}
  q = Expr(:block)
  et = Expr(:tuple)
  zt = Expr(:tuple)
  dt = Expr(:tuple)
  vt = Expr(:tuple)
  eold = :e_0
  zold = :z_0
  dold = :d_0
  vold = :v_0
  i = 0
  for p = 1:P
    ev = Expr(:call, Vec)
    zv = Expr(:call, Vec)
    dv = Expr(:call, Vec)
    vv = Expr(:call, Vec)
    for w = 1:W
      push!(ev.args, eold)
      push!(zv.args, zold)
      push!(dv.args, dold)
      push!(vv.args, vold)
      ((w == W) && (p == P)) && break
      i += 1
      enew = Symbol(:e_, i)
      znew = Symbol(:z_, i)
      dnew = Symbol(:d_, i)
      vnew = Symbol(:v_, i)
      push!(
        q.args,
        :(($enew, $znew, $dnew, $vnew) = jump($eold, $zold, $dold, $vold))
      )
      eold = enew
      zold = znew
      dold = dnew
      vold = vnew
    end
    push!(et.args, ev)
    push!(zt.args, zv)
    push!(dt.args, dv)
    push!(vt.args, vv)
  end
  push!(
    q.args,
    :(XoshiroState(
      VecUnroll($et),
      VecUnroll($zt),
      VecUnroll($dt),
      VecUnroll($vt)
    ))
  )
  q
end

# https://prng.di.unimi.it/xoshiro256starstar.c
@static if VERSION >= v"1.8"
  Base.@assume_effects total function jump(
    eins::UInt64,
    zwei::UInt64,
    drei::UInt64,
    vier::UInt64
  )
    e = zero(UInt64)
    z = zero(UInt64)
    d = zero(UInt64)
    v = zero(UInt64)
    for u ∈ (
      0x180ec6d33cfd0aba,
      0xd5a61266f0c9392c,
      0xa9582618e03fc9aa,
      0x39abdc4529b1661c
    )
      for _ ∈ 0:63
        if u % Bool
          e ⊻= eins
          z ⊻= zwei
          d ⊻= drei
          v ⊻= vier
        end
        u >>>= 1
        e, z, d, v = nextstate(e, z, d, v)
      end
    end
    e, z, d, v
  end
else
  function jump(eins::UInt64, zwei::UInt64, drei::UInt64, vier::UInt64)
    e = zero(UInt64)
    z = zero(UInt64)
    d = zero(UInt64)
    v = zero(UInt64)
    for u ∈ (
      0x180ec6d33cfd0aba,
      0xd5a61266f0c9392c,
      0xa9582618e03fc9aa,
      0x39abdc4529b1661c
    )
      for _ ∈ 0:63
        if u % Bool
          e ⊻= eins
          z ⊻= zwei
          d ⊻= drei
          v ⊻= vier
        end
        u >>>= 1
        e, z, d, v = nextstate(e, z, d, v)
      end
    end
    e, z, d, v
  end
end
@static if VERSION >= v"1.8"
  Base.@assume_effects consistent nothrow terminates_globally function seed(
    s::Base.BitInteger
  )
    i = s % UInt64
    e = z = d = v = zero(UInt64)
    increment = 0xa04de531e612e1b9
    while any(iszero, (e, z, d, v))
      e = ((i * 0x90ce6ecbad5e33b5) + increment)
      z = ((e * 0x90ce6ecbad5e33b5) + increment)
      d = ((z * 0x90ce6ecbad5e33b5) + increment)
      v = ((d * 0x90ce6ecbad5e33b5) + increment)
      increment += 0x0000000000000002
    end
    e, z, d, v
  end
else
  function seed(s::Base.BitInteger)
    i = s % UInt64
    e = z = d = v = zero(UInt64)
    increment = 0xa04de531e612e1b9
    while any(iszero, (e, z, d, v))
      e = ((i * 0x90ce6ecbad5e33b5) + increment)
      z = ((e * 0x90ce6ecbad5e33b5) + increment)
      d = ((z * 0x90ce6ecbad5e33b5) + increment)
      v = ((d * 0x90ce6ecbad5e33b5) + increment)
      increment += 0x0000000000000002
    end
    e, z, d, v
  end
end
seed(s::Integer) = seed((s % UInt64)::UInt64)

function seed!(s::Integer)
  e, z, d, v = seed(s)
  nstreams = XREGISTERS * Base.Threads.nthreads() * pick_vector_width(UInt64)
  initXoshiro!(GLOBAL_vRNGs[], nstreams, e, z, d, v)
end

mutable struct MutableXoshiro{P,W} <: AbstractXoshiro{P}
  state::XoshiroState{P,W}
  @inline function MutableXoshiro(s::Integer)
    MutableXoshiro{XREGISTERS,Int(pick_vector_width(UInt64))}(s)
  end
  @inline function MutableXoshiro{P,W}(s::Integer) where {P,W}
    e, z, d, v = seed(s)
    state = initXoshiro(Val{P}(), Val{W}(), e, z, d, v)
    rng = new{P,W}()
    storestate!(rng, state)
    return rng
  end
end
@inline Base.pointer(rng::MutableXoshiro) =
  Base.unsafe_convert(Ptr{UInt64}, Base.pointer_from_objref(rng))
Xoshiro(m::MutableXoshiro{P}) where {P} = Xoshiro{P}(pointer(m))

"""
Oops, I got the name wrong.
"""
const Xoshift = Xoshiro;

"""
Oops, I got the name wrong.
"""
const MutableXoshift = MutableXoshiro;

# @inline function getstate(rng::AbstractXoshiro{P}, ::Val{N}, ::Val{W}) where {P,N,W}
#     ptr = pointer(rng)
#     XoshiroState(
#         ntuple(n -> vloada(Vec{W,UInt64}, ptr, W64*(n - 1)), Val{N}()),
#         ntuple(n -> vloada(Vec{W,UInt64}, ptr, W64*(n - 1) + W64*P), Val{N}()),
#         ntuple(n -> vloada(Vec{W,UInt64}, ptr, W64*(n - 1) + 2W64*P), Val{N}()),
#         ntuple(n -> vloada(Vec{W,UInt64}, ptr, W64*(n - 1) + 3W64*P), Val{N}())
#     )
# end
@inline function getrandu64counter(rng::Xoshiro{P}) where {P}
  vloadu(
    Base.unsafe_convert(Ptr{UInt8}, pointer(rng)),
    4simd_integer_register_size() * P
  )
end
@inline function getrand64counter(rng::Xoshiro{P}) where {P}
  vloadu(
    Base.unsafe_convert(Ptr{UInt8}, pointer(rng)),
    4simd_integer_register_size() * P + 2
  )
end
@inline function getrandn64counter(rng::Xoshiro{P}) where {P}
  vloadu(
    Base.unsafe_convert(Ptr{UInt8}, pointer(rng)),
    4simd_integer_register_size() * P + 3
  )
end
@inline function setrandu64counter!(rng::Xoshiro{P}, v::UInt8) where {P}
  vstoreu!(
    Base.unsafe_convert(Ptr{UInt8}, pointer(rng)),
    v,
    4simd_integer_register_size() * P
  )
end
@inline function setrand64counter!(rng::Xoshiro{P}, v::UInt8) where {P}
  vstoreu!(
    Base.unsafe_convert(Ptr{UInt8}, pointer(rng)),
    v,
    4simd_integer_register_size() * P + 2
  )
end
@inline function setrandn64counter!(rng::Xoshiro{P}, v::UInt8) where {P}
  vstoreu!(
    Base.unsafe_convert(Ptr{UInt8}, pointer(rng)),
    v,
    4simd_integer_register_size() * P + 3
  )
end

@inline function getstate(rng::AbstractXoshiro{P}) where {P}
  ptr = pointer(rng)
  GC.@preserve rng begin
    XoshiroScalarState(
      vloadu(ptr, StaticInt{0}()),
      vloadu(ptr, simd_integer_register_size() * P),
      vloadu(ptr, 2simd_integer_register_size() * P),
      vloadu(ptr, 3simd_integer_register_size() * P)
    )
  end
end
@inline function getstate(
  rng::AbstractXoshiro{P},
  ::Val{1},
  ::StaticInt{W}
) where {P,W}
  ptr = pointer(rng)
  GC.@preserve rng begin
    XoshiroState(
      VecUnroll((vloada(ptr, MM{W,8}(StaticInt{0}())),)),
      VecUnroll((vloada(ptr, MM{W,8}(simd_integer_register_size() * P)),)),
      VecUnroll((vloada(ptr, MM{W,8}(2simd_integer_register_size() * P)),)),
      VecUnroll((vloada(ptr, MM{W,8}(3simd_integer_register_size() * P)),))
    )
  end
end
@inline function getstate(
  rng::AbstractXoshiro{P},
  ::Val{2},
  ::StaticInt{W}
) where {P,W}
  ptr = pointer(rng)
  GC.@preserve rng begin
    XoshiroState(
      VecUnroll((
        vloada(ptr, MM{W,8}(StaticInt{0}())),
        vloada(ptr, MM{W,8}(simd_integer_register_size()))
      )),
      VecUnroll((
        vloada(ptr, MM{W,8}(P * simd_integer_register_size())),
        vloada(ptr, MM{W,8}(simd_integer_register_size() * (1 + P)))
      )),
      VecUnroll((
        vloada(ptr, MM{W,8}(2P * simd_integer_register_size())),
        vloada(ptr, MM{W,8}(simd_integer_register_size() * (1 + 2P)))
      )),
      VecUnroll((
        vloada(ptr, MM{W,8}(3P * simd_integer_register_size())),
        vloada(ptr, MM{W,8}(simd_integer_register_size() * (1 + 3P)))
      ))
    )
  end
end
@inline function getstate(
  rng::AbstractXoshiro{P},
  ::Val{4},
  ::StaticInt{W}
) where {P,W}
  ptr = pointer(rng)
  GC.@preserve rng begin
    RS = simd_integer_register_size()
    XoshiroState(
      VecUnroll((
        vloada(ptr, MM{W,8}(StaticInt{0}())),
        vloada(ptr, MM{W,8}(RS)),
        vloada(ptr, MM{W,8}(RS * 2)),
        vloada(ptr, MM{W,8}(RS * 3))
      )),
      VecUnroll((
        vloada(ptr, MM{W,8}(P * RS)),
        vloada(ptr, MM{W,8}(RS * (1 + P))),
        vloada(ptr, MM{W,8}(RS * (2 + P))),
        vloada(ptr, MM{W,8}(RS * (3 + P)))
      )),
      VecUnroll((
        vloada(ptr, MM{W,8}(2P * RS)),
        vloada(ptr, MM{W,8}(RS * (1 + 2P))),
        vloada(ptr, MM{W,8}(RS * (2 + 2P))),
        vloada(ptr, MM{W,8}(RS * (3 + 2P)))
      )),
      VecUnroll((
        vloada(ptr, MM{W,8}(3P * RS)),
        vloada(ptr, MM{W,8}(RS * (1 + 3P))),
        vloada(ptr, MM{W,8}(RS * (2 + 3P))),
        vloada(ptr, MM{W,8}(RS * (3 + 3P)))
      ))
    )
  end
end
@inline function storestate!(
  rng::AbstractXoshiro{P},
  s::XoshiroState{N,W}
) where {P,N,W}
  ptr = pointer(rng)
  GC.@preserve rng begin
    @unpack eins, zwei, drei, vier = s
    @inbounds for n ∈ 0:N
      vstorea!(ptr, data(eins)[n], simd_integer_register_size() * n)
    end
    @inbounds for n ∈ 0:N
      vstorea!(ptr, data(zwei)[n], simd_integer_register_size() * (n + P))
    end
    @inbounds for n ∈ 0:N
      vstorea!(ptr, data(drei)[n], simd_integer_register_size() * (n + 2P))
    end
    @inbounds for n ∈ 0:N
      vstorea!(ptr, data(vier)[n], simd_integer_register_size() * (n + 3P))
    end
  end
end
@inline function storestate!(
  rng::AbstractXoshiro{P},
  s::XoshiroScalarState
) where {P}
  ptr = pointer(rng)
  GC.@preserve rng begin
    @unpack eins, zwei, drei, vier = s
    vstorea!(ptr, eins)
    vstorea!(ptr, zwei, P * simd_integer_register_size())
    vstorea!(ptr, drei, 2P * simd_integer_register_size())
    vstorea!(ptr, vier, 3P * simd_integer_register_size())
  end
end
@inline function storestate!(
  rng::AbstractXoshiro{P},
  s::XoshiroState{0,W}
) where {P,W}
  ptr = pointer(rng)
  @unpack eins, zwei, drei, vier = s
  _eins = data(eins)
  _zwei = data(zwei)
  _drei = data(drei)
  _vier = data(vier)
  GC.@preserve rng begin
    @inbounds begin
      vstorea!(ptr, _eins[1])
      vstorea!(ptr, _zwei[1], P * simd_integer_register_size())
      vstorea!(ptr, _drei[1], 2P * simd_integer_register_size())
      vstorea!(ptr, _vier[1], 3P * simd_integer_register_size())
    end
  end
end
@inline function storestate!(
  rng::AbstractXoshiro{P},
  s::XoshiroState{1,W}
) where {P,W}
  ptr = pointer(rng)
  @unpack eins, zwei, drei, vier = s
  _eins = data(eins)
  _zwei = data(zwei)
  _drei = data(drei)
  _vier = data(vier)
  GC.@preserve rng begin
    @inbounds begin
      vstorea!(ptr, _eins[1])
      vstorea!(ptr, _eins[2], simd_integer_register_size())
      vstorea!(ptr, _zwei[1], simd_integer_register_size() * P)
      vstorea!(ptr, _zwei[2], simd_integer_register_size() * (1 + P))
      vstorea!(ptr, _drei[1], simd_integer_register_size() * 2P)
      vstorea!(ptr, _drei[2], simd_integer_register_size() * (1 + 2P))
      vstorea!(ptr, _vier[1], simd_integer_register_size() * 3P)
      vstorea!(ptr, _vier[2], simd_integer_register_size() * (1 + 3P))
    end
  end
end
@inline function storestate!(
  rng::AbstractXoshiro{P},
  s::XoshiroState{3,W}
) where {P,W}
  ptr = pointer(rng)
  @unpack eins, zwei, drei, vier = s
  _eins = data(eins)
  _zwei = data(zwei)
  _drei = data(drei)
  _vier = data(vier)
  GC.@preserve rng begin
    @inbounds begin
      vstorea!(ptr, _eins[1])
      vstorea!(ptr, _eins[2], simd_integer_register_size())
      vstorea!(ptr, _eins[3], simd_integer_register_size() * 2)
      vstorea!(ptr, _eins[4], simd_integer_register_size() * 3)
      vstorea!(ptr, _zwei[1], simd_integer_register_size() * P)
      vstorea!(ptr, _zwei[2], simd_integer_register_size() * (1 + P))
      vstorea!(ptr, _zwei[3], simd_integer_register_size() * (2 + P))
      vstorea!(ptr, _zwei[4], simd_integer_register_size() * (3 + P))
      vstorea!(ptr, _drei[1], simd_integer_register_size() * 2P)
      vstorea!(ptr, _drei[2], simd_integer_register_size() * (1 + 2P))
      vstorea!(ptr, _drei[3], simd_integer_register_size() * (2 + 2P))
      vstorea!(ptr, _drei[4], simd_integer_register_size() * (3 + 2P))
      vstorea!(ptr, _vier[1], simd_integer_register_size() * 3P)
      vstorea!(ptr, _vier[2], simd_integer_register_size() * (1 + 3P))
      vstorea!(ptr, _vier[3], simd_integer_register_size() * (2 + 3P))
      vstorea!(ptr, _vier[4], simd_integer_register_size() * (3 + 3P))
    end
  end
end

@inline function nextstate(eins, zwei, drei, vier)
  t = zwei << 0x0000000000000011
  drei = drei ⊻ eins
  vier = vier ⊻ zwei
  zwei = zwei ⊻ drei
  eins = eins ⊻ vier
  drei = drei ⊻ t
  vier = rotate_right(vier, 0x000000000000002d)
  eins, zwei, drei, vier
end

@generated function _unpack(s::XoshiroState{P}, ::Val{U}) where {P,U}
  if U ≤ P
    quote
      $(Expr(:meta, :inline))
      @unpack eins, zwei, drei, vier = s
      _eins = data(eins)
      _zwei = data(zwei)
      _drei = data(drei)
      _vier = data(vier)
      (
        VecUnroll(Base.Cartesian.@ntuple $U u -> _eins[u]),
        VecUnroll(Base.Cartesian.@ntuple $U u -> _zwei[u]),
        VecUnroll(Base.Cartesian.@ntuple $U u -> _drei[u]),
        VecUnroll(Base.Cartesian.@ntuple $U u -> _vier[u])
      )
    end
  elseif U == P + 1
    quote
      $(Expr(:meta, :inline))
      s.eins, s.zwei, s.drei, s.vier
    end
  else
    throw("$U > $(P+1).")
  end
end

@inline XoshiroState(
  eins::VecUnroll{N},
  zwei::VecUnroll{N},
  drei::VecUnroll{N},
  vier::VecUnroll{N},
  s::XoshiroState{N}
) where {N} = XoshiroState(eins, zwei, drei, vier)
@generated function XoshiroState(
  eins::VecUnroll{N},
  zwei::VecUnroll{N},
  drei::VecUnroll{N},
  vier::VecUnroll{N},
  s::XoshiroState{P}
) where {N,P}
  @assert P > N
  q = quote
    $(Expr(:meta, :inline))
    e = data(eins)
    z = data(zwei)
    d = data(drei)
    v = data(vier)
    _e = data(s.eins)
    _z = data(s.zwei)
    _d = data(s.drei)
    _v = data(s.vier)
  end
  _eins = Expr(:tuple)
  _zwei = Expr(:tuple)
  _drei = Expr(:tuple)
  _vier = Expr(:tuple)
  for n ∈ 1:N+1
    push!(_eins.args, Expr(:ref, :e, n))
    push!(_zwei.args, Expr(:ref, :z, n))
    push!(_drei.args, Expr(:ref, :d, n))
    push!(_vier.args, Expr(:ref, :v, n))
  end
  for n ∈ N+2:P+1
    push!(_eins.args, Expr(:ref, :_e, n))
    push!(_zwei.args, Expr(:ref, :_z, n))
    push!(_drei.args, Expr(:ref, :_d, n))
    push!(_vier.args, Expr(:ref, :_v, n))
  end
  push!(
    q.args,
    :(XoshiroState(
      VecUnroll($_eins),
      VecUnroll($_zwei),
      VecUnroll($_drei),
      VecUnroll($_vier)
    ))
  )
  q
end

@inline function nextstate(s::XoshiroState{P}, ::Val{U}) where {P,U}
  eins, zwei, drei, vier = _unpack(s, Val{U}())
  out = eins + vier
  out = rotate_right(out, 0x0000000000000017)
  eins, zwei, drei, vier = nextstate(eins, zwei, drei, vier)
  # out += eins
  XoshiroState(eins, zwei, drei, vier, s), out
end
@inline function nextstate(s::XoshiroScalarState)
  @unpack eins, zwei, drei, vier = s
  out = eins + vier
  out = rotate_right(out, 0x0000000000000017)
  eins, zwei, drei, vier = nextstate(eins, zwei, drei, vier)
  # out += eins
  XoshiroScalarState(eins, zwei, drei, vier), out
end

function randbuffer64(r::Xoshiro{P}) where {P}
  ptr = pointer(r)
  Buffer256(
    Base.unsafe_convert(Ptr{Float64}, ptr + P * 5simd_integer_register_size())
  )
end
function randnbuffer64(r::Xoshiro{P}) where {P}
  ptr = pointer(r)
  Buffer256(
    Base.unsafe_convert(
      Ptr{Float64},
      ptr + P * 5simd_integer_register_size() + 2048
    )
  )
end
# function randbuffer32(r::Xoshiro{P}) where {P}
#     ptr = pointer(r)
#     Buffer256(Base.unsafe_convert(Ptr{Float64}, ptr + P * 5simd_integer_register_size() + 4096))
# end
function randubuffer64(r::Xoshiro{P}) where {P}
  ptr = pointer(r)
  Buffer256(
    Base.unsafe_convert(
      Ptr{UInt64},
      ptr + P * 5simd_integer_register_size() + 4096
    )
  )
end
# function randnbuffer32(r::Xoshiro{P}) where {P}
#     ptr = pointer(r)
#     Buffer256(Base.unsafe_convert(Ptr{Float64}, ptr + P * 5simd_integer_register_size() + 5120))
# end

module VectorizedRNGStaticArraysExt

using VectorizedRNG: samplevector!, random_uniform, random_normal, AbstractVRNG, random_unsigned
if isdefined(Base, :get_extension)
  using StaticArraysCore
else
  using ..StaticArraysCore
end
using VectorizationBase: StaticInt
import Random

function Random.rand!(
  rng::AbstractVRNG,
  x::StaticArraysCore.MArray{<:Tuple,T},
  α::Number = StaticInt{0}(),
  β = StaticInt{0}(),
  γ = StaticInt{1}()
) where {T<:Union{Float32,Float64}}
  GC.@preserve x begin
    samplevector!(random_uniform, rng, x, α, β, γ, identity)
  end
  return x
end

function Random.randn!(
  rng::AbstractVRNG,
  x::StaticArraysCore.MArray{<:Tuple,T},
  α::Number = StaticInt{0}(),
  β = StaticInt{0}(),
  γ = StaticInt{1}()
) where {T<:Union{Float32,Float64}}
  GC.@preserve x begin
    samplevector!(random_normal, rng, x, α, β, γ, identity)
  end
  return x
end

function Random.rand!(
  rng::AbstractVRNG,
  x::StaticArraysCore.MArray{<:Tuple,UInt64}
)
  samplevector!(
    random_unsigned,
    rng,
    x,
    StaticInt{0}(),
    StaticInt{0}(),
    StaticInt{1}(),
    identity
  )
end


end

using VectorizedRNG
using Test

using InteractiveUtils: versioninfo
versioninfo(; verbose = true)

using RNGTest, Random, SpecialFunctions, Aqua, Distributions, StaticArrays

const α = 1e-4

function smallcrushextrema(res)
  r1 = Base.Cartesian.@ntuple 5 i -> (res[i])::Float64
  r2 = res[6]::Tuple{Float64,Float64}
  r3 = Base.Cartesian.@ntuple 3 i -> (res[i+6])::Float64
  r4 = res[10]::NTuple{5,Float64}
  mi = min(minimum(r1), minimum(r2), minimum(r3), minimum(r4))
  ma = max(maximum(r1), maximum(r2), maximum(r3), maximum(r4))
  mi, ma
end

const INVSQRT2 = Float64(1 / sqrt(big(2)))
# TODO: Get a new SIMD erf implementation
# @inline function normalcdf(v::VectorizedRNG.Vec{W,T}) where {W,T}
#     T(0.5) * ( one(T) + VectorizedRNG.SIMDPirates.verf( v * INVSQRT2 ) )
# end
# function normalcdf!(x::AbstractVector{T}) where {T}
#     _W, Wshift = VectorizedRNG.VectorizationBase.pick_vector_width_shift(T)
#     W = VectorizedRNG.VectorizationBase.pick_vector_width(T)
#     N = length(x)
#     ptrx = pointer(x)
#     i = 0
#     for _ ∈ 1:(N >>> Wshift)
#         ptrxᵢ = VectorizedRNG.VectorizationBase.gep(ptrx, i)
#         v = VectorizedRNG.SIMDPirates.vload(W, ptrxᵢ)
#         VectorizedRNG.SIMDPirates.vstore!(ptrxᵢ, normalcdf(v))
#         i += _W
#     end
#     if i < N
#         ptrxᵢ = VectorizedRNG.VectorizationBase.gep(ptrx, i)
#         mask = VectorizedRNG.VectorizationBase.mask(T, N & (_W - 1))
#         v = VectorizedRNG.SIMDPirates.vload(W, ptrxᵢ, mask)
#         VectorizedRNG.SIMDPirates.vstore!(ptrxᵢ, normalcdf(v), mask)
#     end
#     x
# end
normalcdf(x::T) where {T} = T(0.5) * (one(T) + erf(x * INVSQRT2))
normalcdf!(x::AbstractVector{T}) where {T} = @. x = normalcdf(x)

struct RandNormal01{T<:VectorizedRNG.AbstractVRNG} <: Random.AbstractRNG
  rng::T
end
function Random.rand!(r::RandNormal01, x::AbstractArray)
  randn!(r.rng, x)
  normalcdf!(x)
  # x .= cdf.(Normal(0,1), x)
end
# rngnorm = RNGTest.wrap(RandNormal01(local_pcg()), Float64);

function test_serial_rng(f)
  res = RNGTest.smallcrushJulia(f)
  mi, ma = smallcrushextrema(res)
  @show mi, ma
  @test mi > α
  @test ma < 1 - α
end

@testset "VectorizedRNG.jl" begin
  Aqua.test_all(VectorizedRNG)#, ambiguities = VERSION < v"1.6-DEV")
  VectorizedRNG.seed!(33)
  @test isempty(detect_unbound_args(VectorizedRNG))
  @testset "Small Crush" begin
    rngunif64 = RNGTest.wrap(local_rng(), Float64)
    res = RNGTest.smallcrushJulia(rngunif64)
    mi, ma = smallcrushextrema(res)
    @show mi, ma
    @test mi > α
    @test ma < 1 - α

    rngunif32 = RNGTest.wrap(local_rng(), Float32)
    res = RNGTest.smallcrushJulia(rngunif32)
    mi, ma = smallcrushextrema(res)
    @show mi, ma
    @test mi > α
    @test ma < 1 - α

    rngnorm = RNGTest.wrap(RandNormal01(local_rng()), Float64)
    res = RNGTest.smallcrushJulia(rngnorm)
    mi, ma = smallcrushextrema(res)
    @show mi, ma
    @test mi > α
    @test ma < 1 - α

    mxoshift = VectorizedRNG.MutableXoshift(3)
    rngunif64 = RNGTest.wrap(mxoshift, Float64)
    res = RNGTest.smallcrushJulia(rngunif64)
    mi, ma = smallcrushextrema(res)
    @show mi, ma
    @test mi > α
    @test ma < 1 - α

    rngunif32 = RNGTest.wrap(mxoshift, Float32)
    res = RNGTest.smallcrushJulia(rngunif32)
    mi, ma = smallcrushextrema(res)
    @show mi, ma
    @test mi > α
    @test ma < 1 - α

    rngnorm = RNGTest.wrap(RandNormal01(mxoshift), Float64)
    res = RNGTest.smallcrushJulia(rngnorm)
    mi, ma = smallcrushextrema(res)
    @show mi, ma
    @test mi > α
    @test ma < 1 - α

    A = zeros(13, 29)
    randn!(local_rng(), A)
    @test iszero(sum(iszero, A))
    A .= 0
    randn!(mxoshift, A)
    @test iszero(sum(iszero, A))
    A32 = zeros(Float32, 13, 29)
    randn!(local_rng(), A32)
    @test iszero(sum(iszero, A32))
    A32 .= 0
    randn!(mxoshift, A32)
    @test iszero(sum(iszero, A32))

    # TODO: Support this again
    # rngnorm = RNGTest.wrap(RandNormal01(local_rng()), Float32);
    # res = RNGTest.smallcrushJulia(rngnorm)
    # mi, ma = smallcrushextrema(res)
    # @show mi, ma
    # @test mi > α
    # @test ma < 1 - α

    # scalar mode tests
    test_serial_rng(() -> rand(local_rng()))
    test_serial_rng(() -> normalcdf(randn(local_rng())))
    test_serial_rng(() -> cdf(Gamma(), rand(local_rng(), Gamma())))
    test_serial_rng(
      () ->
        VectorizedRNG.floatbitmask(
          (rand(local_rng(), UInt128) >> 64) % UInt64,
          Float64
        ) - VectorizedRNG.oneopenconst(Float64)
    )
  end
  @testset "Discontiguous in place" begin
    x = zeros(5, 117)
    xv = view(x, 5, :)
    rand!(local_rng(), xv)
    @test !any(iszero, xv)
    @test all(iszero, view(x, 1:4, :))
  end
  @testset "Scaled sampling" begin
    A = Matrix{Float64}(undef, 89, 100)
    randn!(local_rng(), A, VectorizedRNG.StaticInt(0), 5, 100)
    s, l = extrema(A)
    @test s < -100
    @test l > 100
    randn!(local_rng(), A, VectorizedRNG.StaticInt(0), 100, 10)
    @test 90 < sum(A) / length(A) < 110
    randn!(local_rng(), A, VectorizedRNG.StaticInt(1), 100, 10)
    @test 190 < sum(A) / length(A) < 210
  end
  @testset "Correct Sigma" begin
    for T in (Float32, Float64)
      x = Vector{T}(undef, 15)
      s::Float64 = 0.0
      N = 10_000
      vrng = local_rng()
      σ = 0.5
      for i = 1:N
        randn!(vrng, x, VectorizedRNG.StaticInt(0), VectorizedRNG.StaticInt(0), σ)
        s += std(x)
      end
      s /= N
      @test s ≈ σ rtol = 1e-1
    end
  end

  @testset "StaticArrays" begin
    seed = 1234
    rng = local_rng()
    for T in (Float32, Float64, UInt64, Int)
      for dim in ((10),(10,10), (10,10,10))
        A = zeros(T, dim)
        mA = MArray{Tuple{dim...}}(A)
        VectorizedRNG.seed!(seed)
        rand!(rng, A)
        VectorizedRNG.seed!(seed)
        rand!(rng, mA)
        @test all(A .== mA)

        if T <: AbstractFloat
          VectorizedRNG.seed!(seed)
          randn!(rng, A)
          VectorizedRNG.seed!(seed)
          randn!(rng, mA)
          @test all(A .== mA)
        end
      end 
    end   
  end 

end 

using VectorizedRNG
using Documenter

makedocs(;
  modules = [VectorizedRNG],
  authors = "Chris Elrod",
  repo = Remotes.GitHub("JuliaSIMD","VectorizedRNG.jl"),
  sitename = "VectorizedRNG.jl",
  format = Documenter.HTML(;
    prettyurls = get(ENV, "CI", "false") == "true",
    canonical = "https://JuliaSIMD.github.io/VectorizedRNG.jl",
    assets = String[]
  ),
  pages = ["Home" => "index.md"],
  warnonly = true
)

deploydocs(; repo = "github.com/JuliaSIMD/VectorizedRNG.jl")

MatchingUInt(::Type{_Vec{W,Float64}}) where {W} = _Vec{W,UInt64}
MatchingUInt(::Type{Tuple{VecUnroll{N,W,Float64,Vec{W,Float64}}}}) where {N,W} =
  VecUnroll{N,W,UInt64,Vec{W,UInt6}}

@generated MatchingUInt(::Type{Vec{W,Float32}}) where {W} = Vec{W >>> 1,UInt64}
# @generated MatchingUInt(::Type{Tuple{Vec{W,Float32},Vararg{Vec{W,Float32},N}}}) where {N,W} = Tuple{Vec{W>>>1,UInt64},Vararg{Vec{W>>>1,UInt64},N}}
@generated MatchingUInt(
  ::Type{VecUnroll{N,W,Float32,Vec{W,Float32}}}
) where {N,W} = VecUnroll{N,W >>> 1,UInt64,Vec{W >>> 1,UInt64}}

# @generated MatchingFloat32(::Type{Vec{W,UInt64}}) where {W} = Vec{W<<1,Float32}
# @generated MatchingUInt32(::Type{Vec{W,UInt64}}) where {W} = Vec{W<<1,UInt32}

@inline function Random.rand(
  rng::AbstractVRNG{P},
  ::Type{Vec{W,UInt64}}
) where {W,P}
  state = getstate(rng, Val{1}(), StaticInt{W}())
  state, out = nextstate(state, Val{1}())
  storestate!(rng, state)
  data(out)[1]
end
@inline function Random.rand(
  rng::AbstractVRNG{P},
  ::Type{VecUnroll{N,W,UInt64,Vec{W,UInt64}}}
) where {W,P,N}
  state = getstate(rng, Val{P}(), StaticInt{W}())
  state, out = nextstate(state, Val{N}())
  storestate!(rng, state)
  out
end

@inline random_uniform(u::AbstractSIMD{W,UInt64}, ::Type{T}) where {W,T} =
  floatbitmask(u, T) - oneopenconst(T)
# @inline random_uniform(u::Vec{W,UInt64}, ::Type{Float32}) where {W} = floatbitmask(u, Float32) - oneopenconst(Float32)
# @inline random_uniform(u::Vec{W,UInt64}, ::Type{Float32}) where {W} = vsub(floatbitmask(vreinterpret(Vec{W+W,UInt32}, u), Float32), oneopenconst(Float32))
# @generated function random_uniform(u::VecUnroll{N,W,UInt64}, ::Type{T}) where {N,W,T}
#     Expr(
#         :block,
#         Expr(:meta,:inline),
#         Expr(:tuple, [Expr(:call, :random_uniform, Expr(:macrocall, Symbol("@inbounds"), LineNumberNode(@__LINE__,Symbol(@__FILE__)), Expr(:ref, :u, n)), T) for n ∈ 1:N+1]...)
#     )
# end
@inline function Random.rand(
  rng::AbstractVRNG,
  ::Type{VecUnroll{N,W,T,Vec{W,T}}}
) where {N,W,T<:Union{Float32,Float64}}
  random_uniform(rand(rng, MatchingUInt(VecUnroll{N,W,T,Vec{W,T}})), T)
end
"""
Samples uniformly from (0.0,1.0)
"""
@inline function Random.rand(
  rng::AbstractVRNG,
  ::Type{Vec{W,Float64}}
) where {W}
  u = rand(rng, Vec{W,UInt64})
  random_uniform(u, Float64)
end
@generated function Random.rand(rng::AbstractVRNG, ::Type{Vec{W,T}}) where {W,T}
  L = (W * sizeof(T)) >> 3
  @assert L << 3 == W * sizeof(T)
  quote
    $(Expr(:meta, :inline))
    u = rand(rng, Vec{$L,UInt64})
    random_uniform(u, $T)
  end
end
"""
if l < u,
Samples uniformly from [l,u)
else,
Samples uniformly from (u,l]

That is, the "l" side of the interval is closed, and the "u" side is open.
"""
@inline function Random.rand(
  rng::AbstractVRNG,
  ::Type{V},
  l::T,
  u::T
) where {W,T<:Union{Float32,Float64},V<:AbstractSIMD{W,T}}
  s = u - l
  b = l - s
  u = rand(rng, MatchingUInt(Vec{W,T}))
  vfmadd(s, floatbitmask(u, T), b)
end
@inline oneopenconst(::Type{Float64}) = 0.9999999999999999
@inline oneopenconst(::Type{Float32}) = 0.99999994f0

# @generated function Random.rand(rng::AbstractVRNG, ::Type{NTuple{N,Vec{W,T}}}, l::T, u::T) where {N,W,T<:Union{Float32,Float64}}
#     quote
#         $(Expr(:meta,:inline))
#         s = u - l
#         b = l - s
#         u = rand(rng, MatchingUInt(NTuple{N,Vec{W,T}}))
#         $(Expr(:tuple, [:(vfmadd(s, floatbitmask(@inbounds(u[$n]), T), b)) for n ∈ 1:N]...))        
#     end
# end

@inline function randnormal(
  u1::AbstractSIMD{W,UInt64},
  u2::AbstractSIMD{W,UInt64},
  ::Type{T}
) where {W,T<:Union{Float32,Float64}}
  s, c = randsincos(u1, T)
  r = sqrt(nlog01(u2, T))
  s * r, c * r
end
@inline function randnormal(
  u1::AbstractSIMD{1,UInt64},
  u2::AbstractSIMD{1,UInt64},
  ::Type{Float64}
)
  s, c = randsincos(u1(1), Float64)
  r = sqrt(nlog01(u2(1), Float64))
  Vec{1,Float64}((Core.VecElement(s * r),)),
  Vec{1,Float64}((Core.VecElement(c * r),))
end
@inline function randnormal(u1::UInt64, u2::UInt64, ::Type{Float64})
  s, c = randsincos(u1, Float64)
  r = sqrt(nlog01(u2, Float64))
  s * r, c * r
end
@inline function randnormal(u1::UInt64, u2::UInt64, ::Type{Float32})
  s, c = randsincos(Vec(u1), Float32)
  r = sqrt(nlog01(Vec(u2), Float32))
  shufflevector(s * r, Val((0, 1))), shufflevector(c * r, Val((0, 1)))
end

@generated function random_normal(
  vu::VecUnroll{Nm1,W,UInt64,Vec{W,UInt64}},
  ::Type{T}
) where {Nm1,W,T}
  # @assert isodd(Nm1)
  N = Nm1 + 1
  q = Expr(:block, Expr(:meta, :inline), :(u = data(vu)))
  ib = Expr(:block)
  n = 0
  if n < Nm1
    u1t = Expr(:tuple)
    u2t = Expr(:tuple)
    while n < Nm1
      push!(u1t.args, Expr(:ref, :u, n + 1))
      push!(u2t.args, Expr(:ref, :u, n + 2))
      # push!(ib.args, Expr(:(=), Expr(:tuple, Symbol(:n_,n), Symbol(:n_,n+1)), Expr(:call, :randnormal, Expr(:ref, :u, n+1), Expr(:ref, :u, n+2), T)))
      n += 2
    end
    push!(
      ib.args,
      :((sr, cr) = randnormal(VecUnroll($u1t), VecUnroll($u2t), $T))
    )
    push!(ib.args, :(srd = data(sr)))
    push!(ib.args, :(crd = data(cr)))
  end
  nout = Expr(:tuple)
  for n ∈ 1:N>>1
    push!(nout.args, Expr(:ref, :srd, n))
    push!(nout.args, Expr(:ref, :crd, n))
  end
  if n < N # then there is odd remainder
    # we split the vector in two, gen randnormal, and then recombine.
    Wl = (W << 3) ÷ sizeof(T)
    Wh = W >>> 1
    t1 = Expr(:tuple)
    t2 = Expr(:tuple)
    t3 = Expr(:tuple)
    append!(t1.args, 0:Wh-1)
    append!(t2.args, Wh:W-1)
    append!(t3.args, 0:Wl-1)
    lm = Expr(:call, Expr(:curly, :Val, t1))
    um = Expr(:call, Expr(:curly, :Val, t2))
    cm = Expr(:call, Expr(:curly, :Val, t3))
    remq = quote
      ulast = u[$N]
      (sₗ, cᵤ) =
        randnormal(shufflevector(ulast, $lm), shufflevector(ulast, $um), $T)
    end
    push!(ib.args, remq)
    push!(nout.args, :(shufflevector(sₗ, cᵤ, $cm)))
  end
  push!(ib.args, :(nout = $nout))
  push!(
    q.args,
    Expr(
      :macrocall,
      Symbol("@inbounds"),
      LineNumberNode(@__LINE__, Symbol(@__FILE__)),
      ib
    )
  )
  # push!(q.args, Expr(:tuple, [Symbol(:n_,n) for n ∈ 0:N-1]...))
  push!(q.args, :(VecUnroll(nout)))
  q
end

@inline Random.randn(
  rng::AbstractVRNG,
  ::Type{VecUnroll{N,W,T}}
) where {N,W,T} = randn(rng, VecUnroll{N,W,T,Vec{W,T}})
@inline function Random.randn(
  rng::AbstractVRNG,
  ::Type{VecUnroll{N,W,T,Vec{W,T}}}
) where {N,W,T}
  u = rand(rng, MatchingUInt(NTuple{N,Vec{W,T}}))
  random_normal(u, T)
end

@inline function random_uniform(
  state::AbstractState,
  ::Val{N},
  ::Type{T}
) where {N,T}
  state, u = nextstate(state, Val{N}())
  state, random_uniform(u, T)
end
@inline function random_normal(
  state::AbstractState,
  ::Val{N},
  ::Type{T}
) where {N,T}
  state, u = nextstate(state, Val{N}())
  state, random_normal(u, T)
end
@inline scalar_less(n::MM, i) = data(n) < i

@inline zero_pointer(A::AbstractArray) = zero_offsets(stridedpointer(A));
@inline zero_pointer(x) = x
@inline _vload(
  ptr::VectorizationBase.AbstractStridedPointer,
  args::Vararg{Any,K}
) where {K} = vload(ptr, args...)
@inline _vload(x::Number, args::Vararg{Any,K}) where {K} = x

@inline function samplevector!(
  f::F,
  rng::AbstractVRNG{P},
  x::AbstractArray{T},
  α,
  β,
  γ,
  g::G
) where {F,P,T,G}
  state = getstate(rng, Val{2}(), pick_vector_width(UInt64))
  GC.@preserve x begin
    ptrx = zero_pointer(x)
    ptrβ = zero_pointer(β)
    ptrγ = zero_pointer(γ)
    W =
      (pick_vector_width(T) * pick_vector_width(UInt64)) ÷
      pick_vector_width(Float64)
    W2 = W + W
    N = length(x)
    n = MM(W, 0)
    while scalar_less(n, vadd(N, 1 - 2W))
      state, zvu2 = f(state, Val{2}(), T)
      z₁, z₂ = data(zvu2)
      x₁ = vload(ptrx, (n,))
      β₁ = _vload(ptrβ, (n,))
      γ₁ = _vload(ptrγ, (n,))
      x₂ = vload(ptrx, (vadd(W, n),))
      β₂ = _vload(ptrβ, (vadd(W, n),))
      γ₂ = _vload(ptrγ, (vadd(W, n),))
      vstore!(ptrx, g(α * x₁ + z₁ * γ₁ + β₁), (n,))
      vstore!(ptrx, g(α * x₂ + z₁ * γ₂ + β₂), (vadd(W, n),))
      n = vadd(W2, n)
    end
    m = VectorizationBase.mask(W, N)
    if scalar_less(n, vsub(N, W))
      state, zvu2 = f(state, Val{2}(), T)
      z₁, z₂ = data(zvu2)
      x₁ = vload(ptrx, (n,))
      β₁ = _vload(ptrβ, (n,))
      γ₁ = _vload(ptrγ, (n,))
      x₂ = vload(ptrx, (vadd(W, n),), m)
      β₂ = _vload(ptrβ, (vadd(W, n),), m)
      γ₂ = _vload(ptrγ, (vadd(W, n),), m)
      vstore!(ptrx, g(α * x₁ + z₁ * γ₁ + β₁), (n,))
      vstore!(ptrx, g(α * x₂ + z₂ * γ₂ + β₂), (vadd(W, n),), m)
    elseif scalar_less(n, N)
      state, zvu1 = f(state, Val{1}(), T)
      (z₁,) = data(zvu1)
      x₁ = vload(ptrx, (n,), m)
      β₁ = _vload(ptrβ, (n,), m)
      γ₁ = _vload(ptrγ, (n,), m)
      vstore!(ptrx, g(α * x₁ + z₁ * γ₁ + β₁), (n,), m)
    end
    storestate!(rng, state)
  end # GC preserve
  x
end
@inline function samplevector!(
  f::F,
  rng::AbstractVRNG{P},
  x::AbstractArray{T},
  ::StaticInt{0},
  β,
  γ,
  g::G
) where {F,P,T,G}
  state = getstate(rng, Val{2}(), pick_vector_width(UInt64))
  GC.@preserve x begin
    ptrx = zero_pointer(x)
    ptrβ = zero_pointer(β)
    ptrγ = zero_pointer(γ)
    W =
      (pick_vector_width(T) * pick_vector_width(UInt64)) ÷
      pick_vector_width(Float64)
    W2 = W + W
    N = length(x)
    n = MM(W, 0)
    while scalar_less(n, vadd(N, 1 - 2W))
      state, zvu2 = f(state, Val{2}(), T)
      (z₁, z₂) = data(zvu2)
      β₁ = _vload(ptrβ, (n,))
      γ₁ = _vload(ptrγ, (n,))
      β₂ = _vload(ptrβ, (vadd(W, n),))
      γ₂ = _vload(ptrγ, (vadd(W, n),))
      vstore!(ptrx, g(z₁ * γ₁ + β₁), (n,))
      vstore!(ptrx, g(z₂ * γ₂ + β₂), (vadd(W, n),))
      n = vadd(W2, n)
    end
    m = VectorizationBase.mask(W, N)
    if scalar_less(n, vsub(N, W))
      state, zvu2 = f(state, Val{2}(), T)
      (z₁, z₂) = data(zvu2)
      β₁ = _vload(ptrβ, (n,))
      γ₁ = _vload(ptrγ, (n,))
      β₂ = _vload(ptrβ, (vadd(W, n),), m)
      γ₂ = _vload(ptrγ, (vadd(W, n),), m)
      vstore!(ptrx, g(z₁ * γ₁ + β₁), (n,))
      vstore!(ptrx, g(z₂ * γ₂ + β₂), (vadd(W, n),), m)
    elseif scalar_less(n, N)
      state, zvu1 = f(state, Val{1}(), T)
      (z₁,) = data(zvu1)
      β₁ = _vload(ptrβ, (n,), m)
      γ₁ = _vload(ptrγ, (n,), m)
      vstore!(ptrx, g(z₁ * γ₁ + β₁), (n,), m)
    end
    storestate!(rng, state)
  end # GC preserve
  # @show state getstate(rng, Val{2}(), Val{W64}())
  # @assert state === getstate(rng, Val{2}(), Val{W64}())
  x
end

function Random.rand!(
  f::F,
  rng::AbstractVRNG,
  x::AbstractArray{T},
  α::Number = StaticInt{0}(),
  β = StaticInt{0}(),
  γ = StaticInt{1}()
) where {T<:Union{Float32,Float64},F}
  samplevector!(random_uniform, rng, x, α, β, γ, f)
end

function Random.rand!(
  rng::AbstractVRNG,
  x::AbstractArray{T},
  α::Number = StaticInt{0}(),
  β = StaticInt{0}(),
  γ = StaticInt{1}()
) where {T<:Union{Float32,Float64}}
  samplevector!(random_uniform, rng, x, α, β, γ, identity)
end

function Random.randn!(
  rng::AbstractVRNG,
  x::AbstractArray{T},
  α::Number = StaticInt{0}(),
  β = StaticInt{0}(),
  γ = StaticInt{1}()
) where {T<:Union{Float32,Float64}}
  samplevector!(random_normal, rng, x, α, β, γ, identity)
end

@inline function random_unsigned(
  state::AbstractState,
  ::Val{N},
  ::Type{T}
) where {N,T}
  nextstate(state, Val{N}())
end

function Random.rand!(rng::AbstractVRNG, x::AbstractArray{UInt64})
  samplevector!(
    random_unsigned,
    rng,
    x,
    StaticInt{0}(),
    StaticInt{0}(),
    StaticInt{1}(),
    identity
  )
end

Random.rand(rng::AbstractVRNG, d1::Integer, dims::Vararg{Integer,N}) where {N} =
  rand!(rng, Array{Float64}(undef, d1, dims...))
Random.randn(
  rng::AbstractVRNG,
  d1::Integer,
  dims::Vararg{Integer,N}
) where {N} = randn!(rng, Array{Float64}(undef, d1, dims...))
# Random.randexp(rng::AbstractVRNG, d1::Integer, dims::Vararg{Integer,N}) where {N} = randexp!(rng, Array{Float64}(undef, d1, dims...))

struct Buffer256{T} <: DenseVector{T}
  ptr::Ptr{T}
end
Base.pointer(b::Buffer256) = b.ptr
Base.length(::Buffer256) = 256
Base.size(::Buffer256) = (256,)
Base.getindex(b::Buffer256, i::Int) = vload(stridedpointer(b), (i,))
Base.strides(::Buffer256) = (1,)
VectorizationBase.ArrayInterface.contiguous_axis(::Type{<:Buffer256}) =
  VectorizationBase.One()
VectorizationBase.ArrayInterface.contiguous_batch_size(::Type{<:Buffer256}) =
  VectorizationBase.Zero()
VectorizationBase.ArrayInterface.stride_rank(::Type{<:Buffer256}) =
  (VectorizationBase.One(),)

@inline function Random.rand(rng::AbstractVRNG)
  i = getrand64counter(rng)
  b = randbuffer64(rng)
  setrand64counter!(rng, i + 0x01)
  iszero(i) && rand!(rng, b)
  vloadu(pointer(b), VectorizationBase.LazyMulAdd{8,0}(i % UInt32))
end

# Box-Muller for scalars is probably only faster with AVX512, so we use Ziggurat if we don't have it.
@inline function randn_scalar(rng::AbstractVRNG, ::VectorizationBase.True)
  i = getrandn64counter(rng)
  b = randnbuffer64(rng)
  setrandn64counter!(rng, i + 0x01)
  iszero(i) && randn!(rng, b)
  vloadu(pointer(b), VectorizationBase.LazyMulAdd{8,0}(i % UInt32))
end
@inline randn_scalar(rng::AbstractVRNG, ::VectorizationBase.False) =
  Random._randn(rng, rand(rng, Random.UInt52Raw{UInt64}()))
@inline Random.randn(rng::AbstractVRNG) =
  randn_scalar(rng, VectorizationBase.has_feature(Val(:x86_64_avx512f)))

@inline function Random.rand(rng::AbstractVRNG, ::Random.SamplerType{UInt64})
  state, u = nextstate(getstate(rng))
  storestate!(rng, state)
  return u
end
# @inline function Random.rand(rng::AbstractVRNG, ::Random.SamplerType{UInt64})
#     i = getrandu64counter(rng)
#     b = randubuffer64(rng)
#     setrandu64counter!(rng, i + 0x01)
#     iszero(i) && rand!(rng, b)
#     vloadu(pointer(b), VectorizationBase.LazyMulAdd{8,0}(i % UInt32))
# end
@inline Random.rand(rng::AbstractVRNG, ::Random.UInt52Raw{UInt64}) =
  Random.rand(rng, Random.SamplerType{UInt64}())
for T ∈ [:Int8, :UInt8, :Int16, :UInt16, :Int32, :UInt32, :Int64]
  @eval @inline Random.rand(rng::AbstractVRNG, ::Random.SamplerType{$T}) =
    Random.rand(rng, Random.SamplerType{UInt64}()) % $T
end
@inline function Random.rand(
  rng::AbstractVRNG,
  ::Random.SamplerType{T}
) where {T<:Union{UInt128,Int128}}
  i = getrandu64counter(rng)
  b = randubuffer64(rng)
  if i == 0xff
    rand!(rng, b)
    setrandu64counter!(rng, 0x02)
  else
    setrandu64counter!(rng, 0x02 + i)
    iszero(i) && rand!(rng, b)
  end
  vloadu(
    Base.unsafe_convert(Ptr{T}, pointer(b)),
    VectorizationBase.LazyMulAdd{8,0}(i % UInt32)
  )
end
Random.rng_native_52(::AbstractVRNG) = UInt64

"""
setbits(x::Unsigned, y::Unsigned, mask::Unsigned)

If you have AVX512, setbits of vector-arguments will select bits according to mask `m`, selecting from `y` if 0 and from `x` if `1`.
For scalar arguments, or vector arguments without AVX512, `setbits` requires the additional restrictions on `y` that all bits for
which `m` is 1, `y` must be 0.
That is for scalar arguments or vector arguments without AVX512, it requires the restriction that
((y ⊻ m) & m) == m
"""
@inline setbits(x, y, m) = (x & m) | y
@inline function setbits(
  x::Vec{W,U},
  y,
  m,
  ::True
) where {W,U<:Union{UInt32,UInt64}}
  VectorizationBase.vpternlog(
    vbroadcast(Val{W}(), y),
    x,
    vbroadcast(Val{W}(), m),
    Val{216}()
  )
end
@inline function setbits(
  x::VecUnroll{N,W,U},
  y,
  m,
  ::True
) where {N,W,U<:Union{UInt32,UInt64}}
  VectorizationBase.VecUnroll(VectorizationBase.fmap(setbits, data(x), y, m))
end
@inline setbits(x, y, m, ::False) = ((x & m) | y)
@inline setbits(x::VectorizationBase.AbstractSIMD, y, m) =
  setbits(x, y, m, VectorizationBase.has_feature(Val(:x86_64_avx512f)))

"""
The masks mask off bits so that a set of bits will be within the range 1.0 and prevfloat(2.0).
They do this via first using the bitwise-and to set all the exponent bits and the sign-bit to 0,
and then using the bitwise-or to set all but the first exponent bit to 1.
Neither operation touches the fraction-bits.

For example, you can see the binary representation of a double precision number on wikipedia:
https://en.wikipedia.org/wiki/Double-precision_floating-point_format
and then
julia> bitstring(0x000fffffffffffff)
"0000000000001111111111111111111111111111111111111111111111111111"

julia> bitstring(0x3ff0000000000000)
"0011111111110000000000000000000000000000000000000000000000000000"

so that `(x & 0x000fffffffffffff) | 0x3ff0000000000000` has the desired effect of setting the sign
bit to 0, and the exponent bit to be within the proper range.
Note that the second string has 10 "1"s, so that it is 2^10.
For double precision, the exponential contribution is 2^(e - 1023). With e = 2^10,
we have 2^(2^10 - 1023) = 2^(1024 - 1023) = 2^1 = 2.
Thus, the fraction specifies where in the range between 1.0 and prevfloat(2.0).
If the fraction bits are completely random, the distribution will be uniform between 1.0 and prevfloat(2.0).

The reason we target that range (1.0 to prevfloat(2.0)) is to get a nice, uniform distribution.
We can get uniform(0, 1] via 2 - u, or a uniform[0,1) via u - 1.
Choosing other fractional intervals, eg [0.5, 1.0) or [2.0, 4.0) would take more work to translate.
Alternatively, if we tried to span multiple fractional intervals, suddenly trying to get a fairly
uniform distribution would get complicated.
"""
@inline floatbitmask(x, ::Type{Float64}) = reinterpret(
  Float64,
  setbits(reinterpret(UInt64, x), 0x3ff0000000000000, 0x000fffffffffffff)
)
@inline floatbitmask(x, ::Type{Float32}) =
  reinterpret(Float32, setbits(reinterpret(UInt32, x), 0x3f800000, 0x007fffff))
